#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"

#define TIME_OFF -1         //^C}[gpȂꍇ
#define TIME_UP 0           //^CAbv
#define DI_NUM 4            //DItB^̃TvO
#define DI_NO  2
#define	CNT_INIT_MAX 10     //10ms~10 = 100ms
#define TIME_FILTER_MAX 1
#define LCD_TIM_MAX 10
#define RES_MAX 200

#define SLAVE_ADRS 0x3E
#define LINE1_ADRS 0x40
#define LINE2_TOP (0x40 +0x80)
#define FUNC1_SET 0x38
#define FUNC2_SET 0x39
#define INT_OSC 0x14
#define CONST_SET 0x77 //0x73
#define PWR_ICON_SET 0x54 //0x56
#define FOLLOWER_SET 0x6C
#define CLR_DISP 0x01
#define DISP_ONOFF_SET 0x0C

typedef struct{
	uint8_t    wp;
	uint8_t    buf[ DI_NUM ];
    uint8_t    di;
}FILT_DATA;

typedef union{
    uint8_t byte;
    struct{
        uint8_t dmy  :1; //LSB
        uint8_t hot  :1;
        uint8_t so  :1;
        uint8_t su  :1;
        uint8_t rmclr  :1;
        uint8_t ri  :1;
        uint8_t bor  :1;
        uint8_t por :1; //MSB
    }bits;
}START_TYP;

uint8_t CntInit;	//̂ݎgp
FILT_DATA DiData[DI_NO];
int8_t timfilter;   //DItB^N
int16_t timlcd;
int16_t timreswait = TIME_OFF;
uint8_t btncnt;
uint8_t btncntInit;
bool btn1hold;
uint8_t initmoji[2][16] ={"PIC16F1827-RES","         Ver1.00"};
START_TYP starttyp;

void mainTimer(void);
void mainApp(void);
void DiFilterInit(void);
void DiFilter(void);
void LcdInit(void);
void DspLine2Top(void);
void DspClear(void);
void DispSet(void);
void SysStart(void);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    SysStart();  //X^[g̏Ԕf
    DiFilterInit();
    LcdInit();
    timreswait = TIME_OFF;
    
    while (1)
    {
        mainApp();
        DiFilter();        
    }
}
/* CAv */
void mainApp(void){
    
    if( DiData[1].di == 1){
        CLRWDT();
    }
    
    if( DiData[0].di == 1){
        timreswait = TIME_OFF;
    }
    else{
        if( timreswait == TIME_OFF ){
            timreswait = RES_MAX;
        }
    }
    
    if( timlcd == TIME_UP ){
        timlcd = LCD_TIM_MAX;
        DispSet(); //LCD\Zbg
    }
    
    if( timreswait == TIME_UP){
        timreswait = TIME_OFF;
        RESET();
    }
}
/* ^C}Ǘ֐ */
void mainTimer(void){
            
    if( timlcd > TIME_UP ){
        --timlcd;
    }
    if( timfilter > TIME_UP ){
        --timfilter;
    }
    if( timreswait > TIME_UP ){
        --timreswait;
    }
}
// DItB^̏ //
void DiFilterInit(void){
	
    CntInit = CNT_INIT_MAX;
	while(CntInit > 0){  //0ɂȂ܂ŃtB^{
		DiFilter();         //DItB^
        __delay_ms(10);     //10msxDItB^
        CntInit--;
		timfilter = TIME_UP;
	}    
}
//--------SWDItB^----------------------------
void DiFilter(void){
    uint8_t i;
    uint8_t no;
    bool    boo;

    if( timfilter == TIME_UP ){
        timfilter = TIME_FILTER_MAX;

        for( no = 0; no < DI_NO; no++){
            switch(no){
                case 0: //PB2
                    DiData[no].buf[ DiData[no].wp ] = IO_RB2_GetValue();
                    break;
                case 1: //PB3
                    DiData[no].buf[ DiData[no].wp ] = IO_RB3_GetValue();
                    break;
            }
            boo = true;
            for( i = 1; i < DI_NUM; i++){
                if( DiData[no].buf[i-1] != DiData[no].buf[i] ){
                    boo = false;
                    break;
                }
            }

            if( boo ){ ////rĈvl̗p
                 DiData[no].di = DiData[no].buf[ 0 ]; 
            }

            if( ++DiData[no].wp >= DI_NUM){
                    DiData[no].wp = 0;
            }
        }
    }
}
/* LCD̏*/
void LcdInit(void){
    uint8_t i;
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC1_SET ); //WrbgoXE2LINE\
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC2_SET ); //gR}h
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, INT_OSC ); //g
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, CONST_SET ); //RgXg1
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, PWR_ICON_SET );//RgXg2
    __delay_us(40);   
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FOLLOWER_SET );//tH[
    __delay_ms(250);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC1_SET ); //gR}hIt
    __delay_us(40);
    
    DspClear();
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, DISP_ONOFF_SET );
    __delay_us(40);
    
    I2C1_WriteNBytes( SLAVE_ADRS,&initmoji[0][0], sizeof(initmoji[0]));
    
    DspLine2Top();

    for( i = 0; i < sizeof(initmoji[1]); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,initmoji[1][i]);
    }
    __delay_ms(2000);
    DspClear();   
}
/* LCD̃J[\ړ */
void DspLine2Top(void){
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, LINE2_TOP );
    __delay_us(40);    
}
/* LCD̕\*/
void DspClear(void){
  
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, CLR_DISP );
    __delay_us(40);
}
/* DispSet function add */
void DispSet(void){
    uint8_t i;
    uint8_t dsp[16];

    sprintf(dsp,"START TYPE:%u   ", starttyp.byte);
    for( i = 0; i < sizeof(dsp); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,dsp[i]);
    }
  
    DspLine2Top();
    
    if( starttyp.byte == 0 ){
        sprintf(dsp,"COLD START      ");
    }
    else if( starttyp.bits.por == 1 ){
        sprintf(dsp,"RESTART: POR    ");
    }
    else if( starttyp.bits.bor == 1){
        sprintf(dsp,"RESTART: BOR    ");
    }
    else if( starttyp.bits.ri == 1){
        sprintf(dsp,"RESTART: RES    ");
    }   
    else if( starttyp.bits.rmclr == 1 ){
        sprintf(dsp,"RESTART: RMCLR  ");
    }
    else if( starttyp.bits.hot == 1 ){
        sprintf(dsp,"RESTART: HOT    ");
    }
    else{
        sprintf(dsp,"RESTART: OTHER  ");
    }

    for( i = 0; i < sizeof(dsp); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,dsp[i]);
    } 
}
/* ZbgvmF */
void SysStart(void){
    
    if( PCONbits.nBOR == 0 && PCONbits.nPOR == 0 ){
        PCONbits.nPOR = 1;   //p[IZbgNAi0j
        PCONbits.nBOR = 1;   //uEAEgZbgZbgi0)
        PCONbits.nRMCLR = 1;   //MCLRNAi0j 
    }
    else{ //zbgX^[g
        if( PCONbits.nBOR == 0){
            starttyp.bits.bor = 1; //uEAEgZbgŃZbg
            PCONbits.nBOR = 1;   //uEAEgZbgZbgi0j
        }
        if( PCONbits.nPOR == 0 ){
            starttyp.bits.por = 1;
            PCONbits.nPOR = 1;   //p[IZbgNAi0j
        }
        if( PCONbits.nRI == 0){ 
            starttyp.bits.ri = 1;
            PCONbits.nRI = 1;
        }
        if( PCONbits.nRMCLR == 0){ 
            starttyp.bits.rmclr = 1;
            PCONbits.nRMCLR = 1;
        }       
        if( PCONbits.STKOVF == 1 ){ //X^bNI[o[
            starttyp.bits.so = 1;
            PCONbits.STKOVF = 0;
        }
        if( PCONbits.STKUNF == 1 ){ //X^bNA_[t[
            starttyp.bits.su = 1;
            PCONbits.STKUNF = 0;
        }
        starttyp.bits.hot = 1; //zbgX^[gƂZbg
    }
}
/* End of File */